package com.steerinfo.baseinfo.meterbasecarblacelist.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasecarblacelist.model.MeterBaseCarBlacelist;
import com.steerinfo.baseinfo.meterbasecarblacelist.service.IMeterBaseCarBlacelistService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseCarBlacelist RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-22 10:31
 * 类描述
 * 修订历史：
 * 日期：2020-06-22
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCarBlacelist RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecarblacelists")
@Api(value = "/${api.version}/meterbasecarblacelists", tags = "车辆黑名单配置 - MeterBaseCarBlacelistController")
public class MeterBaseCarBlacelistController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCarBlacelistService meterBaseCarBlacelistService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecarblacelist:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCarBlacelist> list = meterBaseCarBlacelistService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecarblacelist:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCarBlacelist> list = meterBaseCarBlacelistService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建-网页", notes = "根据MeterBaseCarBlacelist对象创建")
    @ApiImplicitParam(name = "meterBaseCarBlacelist", value = "详细实体meterBaseCarBlacelist", required = true, dataType = "MeterBaseCarBlacelist")
    //@RequiresPermissions("meterbasecarblacelist:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseCarBlacelist model) {
        try {
            String msg = meterBaseCarBlacelistService.checkandadd(model);
            //system.out.println(msg);
            if (StringUtils.isNotEmpty(msg)) {
//       msg != null && !msg.equals("")
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarblacelist:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCarBlacelist meterBaseCarBlacelist = meterBaseCarBlacelistService.getById(id);
            return success(meterBaseCarBlacelist);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCarBlacelist信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCarBlacelist", value = "详细实体meterBaseCarBlacelist", required = true, dataType = "MeterBaseCarBlacelist")
    })
    //@RequiresPermissions("meterbasecarblacelist:update")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCarBlacelist model) {
        try {
            String msg = meterBaseCarBlacelistService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarblacelist:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseCarBlacelistService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "撤销-网页", notes = "根据传入实体来指定更新对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarblacelist:delete")
    @PostMapping(value = "/cancel")//String
    public RESTfulResult cancel(@RequestBody List<MeterBaseCarBlacelist> models) {
        try {
            String msg = meterBaseCarBlacelistService.cancel(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "启用-网页", notes = "根据传过来的meterBaseCarBlacelist集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "meterBaseCarBlacelist", value = "详细实体meterBaseCarBlacelist", required = true, dataType = "meterBaseCarBlacelist")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody List<MeterBaseCarBlacelist> models) {
        try {
            String msg = meterBaseCarBlacelistService.Recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "废除", notes = "根据传过来的meterBaseCarBlacelist集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "meterBaseCarBlacelist", value = "详细实体meterBaseCarBlacelist", required = true, dataType = "meterBaseCarBlacelist")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCarBlacelist> models) {
        try {
            String msg = meterBaseCarBlacelistService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "判断车辆是否为一级黑名单", notes = "判断车辆是否为一级黑名单")
    @GetMapping(value = "/blackCarByCarNo")
    public RESTfulResult blackCarByCarNo(@RequestParam HashMap parmas) {
        try {
            RESTfulResult rm = meterBaseCarBlacelistService.blackCarByCarNo(parmas);
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "查询所有为一级黑名单的车辆", notes = "查询所有为一级黑名单的车辆")
    @GetMapping(value = "/allBlackCarByCarNo")
    public RESTfulResult allBlackCarByCarNo() {
        try {
            RESTfulResult rm = meterBaseCarBlacelistService.allBlackCarByCarNo();
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
